<?php declare(strict_types = 1);

namespace Drupal\layout_builder_tomsaw\EventSubscriber;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

final class LayoutBuilderTomsawRouteSubscriber extends RouteSubscriberBase {

  /**
   * Don't use admin routes when editing block_content so the correct twig and css is used
   * For the Layout task, a patch is required. @see patche/block_content_dont_use_admin_route.patch
   */
  protected function alterRoutes(RouteCollection $collection): void {
    // @see https://www.drupal.org/node/2187643

    // @see block_content.routing.yml
    $block_content_routes = [
      // @todo: currently, entity.block_content.canonical shows the edit form. Use display instead!
      'entity.block_content.canonical',
      'entity.block_content.edit_form',
      'entity.block_content.delete_form'
    ];
    foreach($block_content_routes as $route_name) {
      if($route = $collection->get($route_name)) {
        $route->setOption('_admin_route', false);
      }
    }
  }

}
