

# %%
from pathlib import Path;
import yaml

options = Path('../scss/styles/_options.scss')
ui_styles = Path('../layout_builder_tomsaw.ui_styles.yml')

def capitalize(size: str):
    n_upper = size.rfind('x') + 1
    return size[:n_upper + 1].upper() + size[n_upper + 1:]

# fetch latest size-options
with open(options) as stream:
    options = {k.lstrip('$'): v.rstrip(';').split(', ') for k, v in yaml.safe_load(stream).items()}
    size_options = {size: capitalize(size) for size in options['size_options']}

with open(ui_styles) as stream:
    styles = yaml.full_load(stream)

    for key, value in styles.items():
        if value['category'] in ['Gap', 'Margin', 'Padding']:
            key_comps = key.split('_')
            if key_comps[1] == 'block':
                key_comps[1][0] = 'k' # to not colide with bottom

            prefix = ''.join([v[0] for v in key_comps]) + '-'
            styles[key]['options'] = {prefix + size: label for size, label in size_options.items()}


# with open(ui_styles, 'w') as stream:
#     yaml.dump(styles, stream, sort_keys=False)
